DATA = {
  "Examples": [], 
  "dist": "bob.pad.base-1.0.6-py_0", 
  "python-scripts": [
    "spoof.py"
  ], 
  "site-packages": [
    "bob.pad.base-1.0.6-py3.6.egg-info/PKG-INFO", 
    "bob.pad.base-1.0.6-py3.6.egg-info/SOURCES.txt", 
    "bob.pad.base-1.0.6-py3.6.egg-info/dependency_links.txt", 
    "bob.pad.base-1.0.6-py3.6.egg-info/entry_points.txt", 
    "bob.pad.base-1.0.6-py3.6.egg-info/requires.txt", 
    "bob.pad.base-1.0.6-py3.6.egg-info/top_level.txt", 
    "bob/pad/__init__.py", 
    "bob/pad/base/__init__.py", 
    "bob/pad/base/algorithm/Algorithm.py", 
    "bob/pad/base/algorithm/__init__.py", 
    "bob/pad/base/config/__init__.py", 
    "bob/pad/base/config/grid/__init__.py", 
    "bob/pad/base/config/grid/demanding.py", 
    "bob/pad/base/database/__init__.py", 
    "bob/pad/base/database/database.py", 
    "bob/pad/base/database/file.py", 
    "bob/pad/base/database/filelist/__init__.py", 
    "bob/pad/base/database/filelist/driver.py", 
    "bob/pad/base/database/filelist/models.py", 
    "bob/pad/base/database/filelist/query.py", 
    "bob/pad/base/evaluation/PadIsoMetrics.py", 
    "bob/pad/base/evaluation/__init__.py", 
    "bob/pad/base/script/__init__.py", 
    "bob/pad/base/script/spoof.py", 
    "bob/pad/base/test/__init__.py", 
    "bob/pad/base/test/data/attack1.wav", 
    "bob/pad/base/test/data/attack2.wav", 
    "bob/pad/base/test/data/attack3.wav", 
    "bob/pad/base/test/data/example_filelist/dev/for_attack.lst", 
    "bob/pad/base/test/data/example_filelist/dev/for_real.lst", 
    "bob/pad/base/test/data/example_filelist/eval/for_attack.lst", 
    "bob/pad/base/test/data/example_filelist/eval/for_real.lst", 
    "bob/pad/base/test/data/example_filelist/train/for_attack.lst", 
    "bob/pad/base/test/data/example_filelist/train/for_real.lst", 
    "bob/pad/base/test/data/pad_devel_replaymobile_IqmScores_SVM.hdf5", 
    "bob/pad/base/test/data/pad_test_replaymobile_IqmScores_SVM.hdf5", 
    "bob/pad/base/test/data/real1.wav", 
    "bob/pad/base/test/data/real2.wav", 
    "bob/pad/base/test/data/real3.wav", 
    "bob/pad/base/test/data/real4.wav", 
    "bob/pad/base/test/data/scores-dev", 
    "bob/pad/base/test/data/scores-dev-attack", 
    "bob/pad/base/test/data/scores-dev-real", 
    "bob/pad/base/test/data/scores-eval", 
    "bob/pad/base/test/data/scores-eval-attack", 
    "bob/pad/base/test/data/scores-eval-real", 
    "bob/pad/base/test/data/scores-train", 
    "bob/pad/base/test/data/scores-train-attack", 
    "bob/pad/base/test/data/scores-train-real", 
    "bob/pad/base/test/data/test_db.sql3", 
    "bob/pad/base/test/dummy/__init__.py", 
    "bob/pad/base/test/dummy/algorithm.py", 
    "bob/pad/base/test/dummy/database.py", 
    "bob/pad/base/test/dummy/database_sql.py", 
    "bob/pad/base/test/dummy/extractor.py", 
    "bob/pad/base/test/dummy/filelist.py", 
    "bob/pad/base/test/dummy/preprocessor.py", 
    "bob/pad/base/test/test.py", 
    "bob/pad/base/test/test_PadIsoMetrics.py", 
    "bob/pad/base/test/test_databases.py", 
    "bob/pad/base/test/test_filelist.py", 
    "bob/pad/base/test/test_spoof.py", 
    "bob/pad/base/tools/FileSelector.py", 
    "bob/pad/base/tools/__init__.py", 
    "bob/pad/base/tools/algorithm.py", 
    "bob/pad/base/tools/command_line.py", 
    "bob/pad/base/tools/extractor.py", 
    "bob/pad/base/tools/preprocessor.py", 
    "bob/pad/base/tools/scoring.py"
  ]
}
## END DATA

"""
This is code that is added to noarch Python packages. See
conda_build/noarch_python.py.

"""
import os
from os.path import dirname, exists, isdir, join, normpath
import sys
import shutil


# Silence pyflakes. This variable is added when link.py is written by
# conda_build.noarch_python.
if False:
    DATA = None

THIS_DIR = dirname(__file__)
PREFIX = normpath(sys.prefix)
if sys.platform == 'win32':
    BIN_DIR = join(PREFIX, 'Scripts')
    SITE_PACKAGES = 'Lib/site-packages'
else:
    BIN_DIR = join(PREFIX, 'bin')
    SITE_PACKAGES = 'lib/python%s/site-packages' % sys.version[:3]

# the list of these files is going to be store in info/_files
FILES = []


def _link(src, dst):
    try:
        os.link(src, dst)
        # on Windows os.link raises AttributeError
    except (OSError, AttributeError):
        shutil.copy2(src, dst)


def _unlink(path):
    try:
        os.unlink(path)
    except OSError:
        pass


def pyc_f(f, version_info=sys.version_info):
    if version_info[0] == 2:
        return f + 'c'
    dn, fn = f.rsplit('/', 1)
    return '%s/__pycache__/%s.cpython-%d%d.pyc' % (
              dn, fn[:-3], version_info[0], version_info[1])


def link_files(src_root, dst_root, files):
    for f in files:
        src = join(THIS_DIR, src_root, f)
        dst = join(PREFIX, dst_root, f)
        dst_dir = dirname(dst)
        if not isdir(dst_dir):
            os.makedirs(dst_dir)
        if exists(dst):
            _unlink(dst)
        _link(src, dst)
        f = '%s/%s' % (dst_root, f)
        FILES.append(f)
        if f.endswith('.py'):
            FILES.append(pyc_f(f))


def create_script(fn):
    src = join(THIS_DIR, 'python-scripts', fn)
    dst = join(BIN_DIR, fn)
    if sys.platform == 'win32':
        shutil.copy2(src, dst + '-script.py')
        FILES.append('Scripts/%s-script.py' % fn)
        shutil.copy2(join(THIS_DIR,
                          'cli-%d.exe' % (8 * tuple.__itemsize__)),
                     dst + '.exe')
        FILES.append('Scripts/%s.exe' % fn)
    else:
        with open(src) as fi:
            data = fi.read()
        with open(dst, 'w') as fo:
            fo.write('#!%s\n' % normpath(sys.executable))
            fo.write(data)
        os.chmod(dst, 0o775)
        FILES.append('bin/%s' % fn)


def create_scripts(files):
    if not files:
        return
    if not isdir(BIN_DIR):
        os.mkdir(BIN_DIR)
    for fn in files:
        create_script(fn)


def main():
    create_scripts(DATA['python-scripts'])
    link_files('site-packages', SITE_PACKAGES, DATA['site-packages'])
    link_files('Examples', 'Examples', DATA['Examples'])

    with open(join(PREFIX, 'conda-meta',
                   '%s.files' % DATA['dist']), 'w') as fo:
        for f in FILES:
            fo.write('%s\n' % f)


if __name__ == '__main__':
    main()
